<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Real-time Monitoring &mdash; 4PointX Documentation 1.0 documentation</title>
      <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/doctools.js"></script>
        <script src="../../../../_static/sphinx_highlight.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
    <link rel="next" title="Process Correlation" href="../process_correlation/index.html" />
    <link rel="prev" title="Asset Health Dashboard" href="../asset_health_dashboard/index.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../../index.html" class="icon icon-home">
            4PointX Documentation
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../../introduction/index.html">Introduction</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../getting_started_with_4pointx_cloud/index.html">Getting Started with 4PointX Cloud</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../deploy_4pointx_self_managed/index.html">Deploy 4PointX Self-Managed</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/pre_requisites/index.html">Pre-requisites</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/pre_installation_guide/index.html">Pre Installation Guide</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/pre_installation_guide/k8s_installation_guide/index.html">K8S Installation Guide</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/pre_installation_guide/helm_installation_guide/index.html">Helm Installation Guide</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/deploy_4pointx_iaot_suite/index.html">Deploy 4PointX IAoT Suite</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/log_in_to_4pointx_iaot_suite/index.html">Log in to 4PointX IAoT Suite</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/index.html">Upgrade or Uninstall 4PointX</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/upgrade_4pointx_platform/index.html">Upgrade 4PointX Platform</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/upgrade_or_uninstall_4pointx/uninstall_4pointx_platform/index.html">Uninstall 4PointX Platform</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/maintain_4px_cluster/index.html">Maintain 4PX Cluster</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/maintain_4px_cluster/k8s_dashboard_guide/index.html">K8S DASHBOARD Guide</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/maintain_4px_cluster/resize_4px_modules/index.html">Resize 4PX Modules</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/tls_security/index.html">TLS Security</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/tls_security/index.html#design">Design</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../deploy_4pointx_self_managed/tls_security/index.html#updating-ssl-certificates">Updating SSL Certificates</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../deploy_4pointx_self_managed/next_steps/index.html">Next Steps</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1 current"><a class="reference internal" href="../../index.html">Apps</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../../energy_monitoring_system_ems/index.html">Energy Monitoring System (EMS)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../energy_monitoring_system_ems/specific_energy/index.html">Specific Energy</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../energy_monitoring_system_ems/idle_energy/index.html">Idle Energy</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../energy_monitoring_system_ems/product_variation/index.html">Product Variation</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../energy_monitoring_system_ems/other_info_ems/index.html">Other Info - EMS</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html">Articles &amp; References - EMS</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#power-meters">Power Meters</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#oem-vendors">OEM Vendors</a></li>
<li class="toctree-l5"><a class="reference internal" href="../../energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#articles">Articles</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../energy_monitoring_system_ems/other_info_ems/articles_references_ems/index.html#things-you-should-consider-when-choosing-a-power-meter">3 Things You Should Consider When Choosing a Power Meter</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2 current"><a class="reference internal" href="../index.html">Condition-based Maintenance (CBM)</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="../summary/index.html">Summary</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../asset_health_dashboard/index.html">Asset Health Dashboard</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Real-time Monitoring</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#grouping-interval-logic-implemented-in-the-front-end">Grouping Interval logic implemented in the Front-End:</a></li>
<li class="toctree-l4"><a class="reference internal" href="#code">Code:</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id1">Code:</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../process_correlation/index.html">Process Correlation</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../fault_diagnostics/index.html">Fault Diagnostics</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../other_info_cm/index.html">Other Info - CM</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html">Competitor Solutions - CM</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#teco-group">Teco Group</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#infinite-uptime">Infinite Uptime</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#web-app">Web App</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#sensor-manual">Sensor Manual</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#api-documentation">API Documentation</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#rs-485-modbus-specs">RS-485/ Modbus Specs</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#dashboard">Dashboard</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#gd-folder">GD Folder</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#datakrew">DataKrew</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#sample-cases">Sample Cases</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#case-1">Case 1</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#diagnostics">Diagnostics</a></li>
<li class="toctree-l6"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#detailed-report-attached">Detailed report attached</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#case-2">Case 2</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#id1">Diagnostics</a></li>
<li class="toctree-l6"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#id2">Detailed report attached</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#bk-vibro">BK Vibro</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#gantner-instruments">Gantner Instruments</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#vibro-meter">Vibro-meter</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#omnidots">Omnidots</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#rokade-rototechniks">Rokade Rototechniks</a></li>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/competitor_solutions_cm/index.html#cmtechnologies">cmtechnologies</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="../other_info_cm/articles_and_blogs_cm/index.html">Articles and Blogs - CM</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../other_info_cm/articles_and_blogs_cm/index.html#treatment-for-machine-vibration-problems">Treatment for Machine Vibration Problems</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../predictive_maintenance_pdm/index.html">Predictive Maintenance (PdM)</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../predictive_maintenance_pdm/asset_anomalies/index.html">Asset Anomalies</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../predictive_maintenance_pdm/process_anomalies/index.html">Process Anomalies</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../predictive_maintenance_pdm/other_info_pdm/index.html">Other Info - PdM</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../predictive_maintenance_pdm/other_info_pdm/competitor_solutions_anomaly/index.html">Competitor Solutions - Anomaly</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../predictive_maintenance_pdm/other_info_pdm/competitor_solutions_anomaly/index.html#sparkcognition">SparkCognition</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="../../predictive_maintenance_pdm/other_info_pdm/digital_twin_articles/index.html">Digital Twin articles</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../dashboards/index.html">Dashboards</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../alerting/index.html">Alerting</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../alerting/alerts/index.html">Alerts</a><ul class="simple">
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../alerting/watchers/index.html">Watchers</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../notebooks/index.html">Notebooks</a><ul class="simple">
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../data_management/index.html">Data Management</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../data_management/iot_gateways/index.html">IoT Gateways</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html">IoT Gateways Introduction</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#data-onboarding">Data Onboarding</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#edge-iot-gateway">Edge IoT Gateway</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#modbus-rtu">Modbus RTU</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#opc-ua">OPC-UA</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#opc-server-python-producer-kafka-python-consumer-elasticsearch">OPC Server &gt; Python (Producer) &gt; Kafka &gt; Python (Consumer) &gt; Elasticsearch</a></li>
</ul>
</li>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#modbus-tcp">Modbus TCP</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#file">File</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#steps-to-onboard-data-from-file">Steps to onboard data from File</a></li>
<li class="toctree-l7"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#installing-logstash">Installing Logstash</a><ul>
<li class="toctree-l8"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#centos">CentOS</a></li>
</ul>
</li>
<li class="toctree-l7"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#testing-transformed-data">Testing Transformed Data</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#third-party-apps">Third-Party Apps</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#infinite-uptime">Infinite Uptime</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#cimcon-digital">CimCon Digital</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#cloud">Cloud</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#aws-s3">AWS S3</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#google-cloud-storage">Google Cloud Storage</a></li>
<li class="toctree-l6"><a class="reference internal" href="../../../data_management/iot_gateways/iot_gateways_introduction/index.html#azure-data-lake">Azure Data Lake</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../data_management/iot_gateways/edge_iot_gateways/index.html">Edge IoT Gateways</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../data_management/iot_gateways/edge_iot_gateways/index.html#initial-configuration-steps">Initial Configuration Steps</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../data_management/iot_gateways/edge_iot_gateways/index.html#testing-modbus-slaves">Testing Modbus Slaves</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../data_management/asset_metadata/index.html">Asset Metadata</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../data_management/asset_metadata/plants/index.html">Plants</a><ul class="simple">
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../data_management/asset_metadata/functions/index.html">Functions</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../data_management/asset_metadata/functions/function_monitors/index.html">Function Monitors</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../data_management/asset_metadata/assets/index.html">Assets</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../data_management/asset_metadata/assets/asset_monitors/index.html">Asset Monitors</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../administration/index.html">Administration</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../administration/user_management/index.html">User Management</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../administration/user_management/security_rbac/index.html">Security - RBAC</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../administration/user_management/security_rbac/index.html#roles">Roles</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../administration/user_management/security_rbac/index.html#plant-viewer">Plant Viewer</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../administration/user_management/security_rbac/index.html#plant-analyst">Plant Analyst</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../administration/user_management/security_rbac/index.html#plant-admin">Plant Admin</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../administration/user_management/security_rbac/index.html#site-admin">Site Admin</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../../../administration/user_management/support_users/index.html">Support Users</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../administration/user_management/support_users/index.html#steps-to-create-support-users-ui">Steps to create support users (UI)</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../administration/user_management/support_users/index.html#create-support-users-using-dev-tools">Create support users using Dev Tools</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../administration/user_management/support_users/index.html#repeat-step-no-5-for-support-admin-user">Repeat Step No. 5 for support-admin user.</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../administration/license_management/index.html">License Management</a><ul class="simple">
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../partners/index.html">Partners</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../partners/oem_partners/index.html">OEM Partners</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../partners/oem_partners/index.html#hardware-partners">Hardware Partners</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../partners/oem_partners/index.html#other-info">Other Info</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../partners/oem_partners/index.html#tecom">Tecom</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../partners/oem_partners/index.html#durham-instruments">Durham Instruments</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../partners/oem_partners/index.html#https-disensors-com-products-accelerometers-mems">https://disensors.com/products/accelerometers/mems/</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../../partners/oem_partners/index.html#converters">Converters</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../test_page_for_sphinix_converter/index.html">Test page for sphinix converter</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../test_page_for_sphinix_converter/index.html#header-2">Header 2</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../test_page_for_sphinix_converter/index.html#header-3">Header 3</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../../test_page_for_sphinix_converter/index.html#header-4">Header 4</a><ul>
<li class="toctree-l5"><a class="reference internal" href="../../../test_page_for_sphinix_converter/index.html#header-5">Header 5</a><ul>
<li class="toctree-l6"><a class="reference internal" href="../../../test_page_for_sphinix_converter/index.html#header-6">Header 6</a><ul>
<li class="toctree-l7"><a class="reference internal" href="../../../test_page_for_sphinix_converter/how_to/index.html">How to</a><ul class="simple">
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">API Documentation</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../API/Asset_Metadata/index.html"><strong>Asset Metadata APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/assets.html"><strong>Assets</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/assets.html#create-asset"><strong>Create Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/assets.html#delete-asset"><strong>Delete Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/assets.html#update-asset"><strong>Update Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/assets.html#fetch-asset"><strong>Fetch Asset</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/assets.html#fetch-list-of-assets"><strong>Fetch List of Assets</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/assets.html#get-count-of-assets"><strong>Get Count of Assets</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/functions.html"><strong>Functions</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/functions.html#create-a-function"><strong>Create a Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/functions.html#delete-a-function"><strong>Delete a Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/functions.html#update-function"><strong>Update Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/functions.html#fetch-function"><strong>Fetch Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/functions.html#fetch-list-of-functions"><strong>Fetch List of Functions</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/monitors.html"><strong>Monitors</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/monitors.html#create-a-monitor"><strong>Create a Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/monitors.html#delete-monitor"><strong>Delete Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/monitors.html#update-monitor"><strong>Update Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/monitors.html#fetch-monitors"><strong>Fetch Monitors</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/monitors.html#fetch-list-of-monitors"><strong>Fetch List of Monitors</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/monitors.html#get-count-of-monitors"><strong>Get Count of Monitors</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/plants.html"><strong>Plants</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/plants.html#create-a-plant"><strong>Create a Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/plants.html#delete-a-plant"><strong>Delete a Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/plants.html#update-plant"><strong>Update Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/plants.html#fetch-plant"><strong>Fetch Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/plants.html#fetch-list-of-plants"><strong>Fetch List of Plants</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines.html"><strong>Pipelines</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines.html#fetch-list-of-pipelines"><strong>Fetch List of Pipelines</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines.html#count-pipelines"><strong>Count Pipelines</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines.html#execute-pipeline-action"><strong>Execute Pipeline Action</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_edge.html"><strong>Pipelines (Edge Server)</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_edge.html#create-edge-server-pipeline"><strong>Create Edge Server Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_edge.html#delete-pipeline"><strong>Delete Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_edge.html#update-pipeline"><strong>Update Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_edge.html#fetch-pipeline"><strong>Fetch Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_edge.html#handshake"><strong>Handshake</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_edge.html#firmware"><strong>Firmware</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_IU.html"><strong>Pipelines (Infinite Uptime)</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_IU.html#create-iu-pipeline"><strong>Create IU Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_IU.html#delete-pipeline"><strong>Delete Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_IU.html#update-pipeline"><strong>Update Pipeline</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/pipelines_IU.html#fetch-pipeline"><strong>Fetch Pipeline</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/sites.html"><strong>Sites</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/sites.html#create-a-new-site"><strong>Create a New Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/sites.html#delete-site"><strong>Delete Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/sites.html#update-site"><strong>Update Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/sites.html#fetch-site"><strong>Fetch Site</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/sites.html#fetch-list-of-sites"><strong>Fetch List of Sites</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/samples.html"><strong>Samples</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/samples.html#retrieve-sample-trend"><strong>Retrieve Sample Trend</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/samples.html#retrieve-sample-count"><strong>Retrieve Sample Count</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/tags.html"><strong>Tags</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/tags.html#retrieve-tags-list"><strong>Retrieve Tags List</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/tags.html#retrieve-tags-count"><strong>Retrieve Tags Count</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/tags.html#query-tags-trend"><strong>Query Tags Trend</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Asset_Metadata/others.html"><strong>Other APIs</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Asset_Metadata/others.html#server-time"><strong>Server Time</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../../API/EMS/index.html"><strong>EMS APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/EMS/ems_asset.html">EMS Asset</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/EMS/ems_benchmarking.html"><strong>EMS Benchmarking</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_benchmarking.html#fetch-product-variation-table-for-plant"><strong>Fetch Product Variation Table for Plant</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/EMS/ems_function.html"><strong>EMS Function</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_function.html#fetch-energy-metrics-for-function"><strong>Fetch Energy Metrics for Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_function.html#fetch-energy-metrics-for-functions-in-plant"><strong>Fetch Energy Metrics for Functions in Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_function.html#fetch-energy-metric-trend-for-function"><strong>Fetch Energy Metric Trend for Function</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/EMS/ems_monitor.html"><strong>EMS Monitor</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_monitor.html#fetch-energy-metrics-for-monitor"><strong>Fetch Energy Metrics for Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_monitor.html#fetch-energy-metrics-monitors-in-plant-or-function"><strong>Fetch Energy Metrics Monitors in Plant or Function</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_monitor.html#fetch-energy-metric-trend-for-monitor"><strong>Fetch Energy Metric trend for Monitor</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/EMS/ems_plant.html"><strong>EMS Plant</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_plant.html#fetch-energy-metrics-for-plant"><strong>Fetch Energy Metrics for Plant</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/EMS/ems_plant.html#fetch-energy-metric-trend-for-plant"><strong>Fetch Energy Metric trend for Plant</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../../API/Notebooks/index.html"><strong>Notebooks APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html"><strong>Notebooks</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#create-notebook"><strong>Create Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#delete-notebook"><strong>Delete Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#rename-notebook"><strong>Rename Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#fetch-notebook-details"><strong>Fetch Notebook Details</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#fetch-list-of-notebooks"><strong>Fetch List of Notebooks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#fetch-count-of-notebooks"><strong>Fetch Count of Notebooks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#run-notebook"><strong>Run Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#schedule-notebook"><strong>Schedule Notebook</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Notebooks/notebooks.html#unschedule-notebook"><strong>Unschedule Notebook</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../../API/Alerting/index.html"><strong>Alerting APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Alerting/alerts.html"><strong>Alerts</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/alerts.html#fetch-alerts-count"><strong>Fetch Alerts Count</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/alerts.html#fetch-list-of-alerts"><strong>Fetch List of Alerts</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/alerts.html#fetch-alerts-trend"><strong>Fetch Alerts Trend</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Alerting/watchers.html"><strong>Watchers</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/watchers.html#create-watcher"><strong>Create Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/watchers.html#delete-watcher"><strong>Delete Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/watchers.html#update-watcher"><strong>Update Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/watchers.html#fetch-watcher"><strong>Fetch Watcher</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/watchers.html#fetch-list-of-watchers"><strong>Fetch List of Watchers</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Alerting/watchers.html#fetch-watcher-count"><strong>Fetch Watcher Count</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../../API/User_Management/index.html"><strong>User Management APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/User_Management/user_management.html"><strong>Users</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/user_management.html#create-new-user"><strong>Create New User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/user_management.html#delete-user"><strong>Delete User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/user_management.html#updating-user"><strong>Updating User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/user_management.html#fetch-user"><strong>Fetch User</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/user_management.html#fetch-list-of-users"><strong>Fetch List of Users</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/User_Management/password.html"><strong>Password</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/password.html#generate-otp"><strong>Generate OTP</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/password.html#validate-otp"><strong>Validate OTP</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/User_Management/password.html#update-user-password"><strong>Update User Password</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../../API/Condition_Monitoring/index.html"><strong>CBM APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_assets.html"><strong>CM Assets</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_assets.html#cm-assets-list"><strong>CM Assets List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_events.html"><strong>CM Events</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_events.html#update-event"><strong>Update Event</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_events.html#fetch-event"><strong>Fetch Event</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_events.html#fetch-event-list"><strong>Fetch Event List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_faults.html"><strong>CM Faults</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_faults.html#cm-fault-s-status"><strong>CM Fault’s Status</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_monitors.html"><strong>CM Monitors</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_monitors.html#cm-monitor"><strong>CM Monitor</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_monitors.html#cm-monitors-list"><strong>CM Monitors List</strong></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_fft.html"><strong>CM FFT</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_fft.html#cm-fft-peaks"><strong>CM FFT Peaks</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_fft.html#cm-asset-fault-summary"><strong>CM Asset Fault Summary</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_fft.html#cm-fft-spectrum"><strong>CM FFT Spectrum</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/Condition_Monitoring/cm_fft.html#cm-fft-spectrum-timestamps"><strong>CM FFT Spectrum Timestamps</strong></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../../../API/License_Management/index.html"><strong>License Management APIs</strong></a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../../../API/License_Management/license_management.html"><strong>Licenses</strong></a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/License_Management/license_management.html#generate-a-license"><strong>Generate a License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/License_Management/license_management.html#update-license"><strong>Update License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/License_Management/license_management.html#get-license"><strong>Get License</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/License_Management/license_management.html#fetch-list-of-licenses"><strong>Fetch List of Licenses</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/License_Management/license_management.html#activate-licenses"><strong>Activate Licenses</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/License_Management/license_management.html#get-notification"><strong>Get Notification</strong></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../../../API/License_Management/license_management.html#verify-app-access"><strong>Verify App Access</strong></a></li>
</ul>
</li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">4PointX Documentation</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Apps</a></li>
          <li class="breadcrumb-item"><a href="../index.html">Condition-based Maintenance (CBM)</a></li>
      <li class="breadcrumb-item active">Real-time Monitoring</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../../_sources/4pointx_docs/apps/condition_based_maintenance_cbm/real_time_monitoring/index.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="real-time-monitoring">
<h1>Real-time Monitoring<a class="headerlink" href="#real-time-monitoring" title="Permalink to this heading">¶</a></h1>
<section id="grouping-interval-logic-implemented-in-the-front-end">
<h2>Grouping Interval logic implemented in the Front-End:<a class="headerlink" href="#grouping-interval-logic-implemented-in-the-front-end" title="Permalink to this heading">¶</a></h2>
<p>We are using a custom function <code>calculateInterval</code> which is responsible for determining the appropriate time interval based on a given number of hours. It rounds the input hours to the nearest integer compares the rounded value with predefined maximum hour thresholds and dispatches the selected interval to the Redux store. If no match is found it returns a default value ('1d' for 1 day).</p></section>
<section id="code">
<h2>Code:<a class="headerlink" href="#code" title="Permalink to this heading">¶</a></h2>
<div class="highlight-text notranslate"><div class="highlight"><pre><span></span>/**
  * Calculates the appropriate time interval based on the given number of hours.
  *
  * This function takes the number of hours as input and rounds it to the nearest integer.
  * It then compares the rounded hours with predefined maximum hour thresholds to determine
  * the suitable time interval. If a match is found it dispatches the interval to the Redux store
  * it returns the selected interval or a default value (&#39;1d&#39; for 1 day).
  *
  * @param {number} hours - The number of hours to calculate the interval for.
  * @returns {string} - The calculated time interval.
  */
 const calculateInterval = useCallback((hours) =&gt; {
   const roundedHours = Math.round(hours);

   if (isNaN(roundedHours) || roundedHours === 0) {
     return &#39;1s&#39;;
   }

   const intervalChoices = [
     { maxHours: 0, interval: &#39;1s&#39; },
     { maxHours: 1, interval: &#39;1s&#39; },
     { maxHours: 2, interval: &#39;2s&#39; },
     { maxHours: 3, interval: &#39;5s&#39; },
     { maxHours: 4, interval: &#39;10s&#39; },
     { maxHours: 8, interval: &#39;20s&#39; },
     { maxHours: 12, interval: &#39;30s&#39; },
     { maxHours: 24, interval: &#39;1m&#39; },
     { maxHours: 48, interval: &#39;2m&#39; },
     { maxHours: 120, interval: &#39;5m&#39; },
     { maxHours: 240, interval: &#39;10m&#39; },
     { maxHours: 480, interval: &#39;30m&#39; },
     { maxHours: 720, interval: &#39;1h&#39; },
     { maxHours: 1440, interval: &#39;2h&#39; },
     { maxHours: 2160, interval: &#39;5h&#39; },
     { maxHours: 4320, interval: &#39;10h&#39; },
     { maxHours: 6480, interval: &#39;12h&#39; },
     { maxHours: 8640, interval: &#39;1d&#39; },
   ];

   for (const { maxHours, interval } of intervalChoices) {
     if (roundedHours &lt;= maxHours &amp;&amp; roundedHours &gt; maxHours / 2) {
       return interval;
     }
   }

   return &#39;1d&#39;;
 }, []);
</pre></div>
</div>
<p><br/></p><p>The <code>parseTimeString</code> function is designed to parse a time string and produce a formatted ISO string representing the calculated time. It supports a variety of time units (seconds, minutes, hours, days, weeks, months, years) and can handle both absolute and relative time expressions.</p><p>We are not using <code>dateMath.parse(time)</code> due to inconsistencies with unparsable strings, where the behavior can vary between returning <code>undefined</code> and providing an invalid moment.</p></section>
<section id="id1">
<h2>Code:<a class="headerlink" href="#id1" title="Permalink to this heading">¶</a></h2>
<div class="highlight-text notranslate"><div class="highlight"><pre><span></span>/**
   * Parses a time string and returns a formatted ISO string representing the calculated time.
   *
   * This function takes a time string as input and processes it to determine the corresponding
   * time based on the provided format. It supports various units (seconds, minutes, hours, days,
   * weeks, months, years) and can handle relative time expressions like &#39;now-5d&#39; (5 days ago) or
   * &#39;now+3h&#39; (3 hours from now). If &#39;now&#39; is provided, it returns the current time in ISO format.
   *
   * @param {string} timeString - The time string to be parsed (e.g., &#39;now-5d&#39;, &#39;now+3h&#39;).
   * @returns {string} - The formatted ISO string representing the calculated time.
   */
  const parseTimeString = (timeString) =&gt; {
    if (timeString === &#39;now&#39;) {
      // Return the current time if &#39;now&#39; is provided
      return moment().toISOString();
    }

    const now = moment();

    const regex = /now([+-])(\d+)([smhdwMy])/;
    const match = regex.exec(timeString);

    if (match) {
      const operator = match[1];
      const value = parseInt(match[2], 10);
      const unit = match[3];

      switch (unit) {
        case &#39;s&#39;:
          return operator === &#39;+&#39;
            ? now.add(value, &#39;seconds&#39;).toISOString()
            : now.subtract(value, &#39;seconds&#39;).toISOString();
        case &#39;m&#39;:
          return operator === &#39;+&#39;
            ? now.add(value, &#39;minutes&#39;).toISOString()
            : now.subtract(value, &#39;minutes&#39;).toISOString();
        case &#39;h&#39;:
          return operator === &#39;+&#39;
            ? now.add(value, &#39;hours&#39;).toISOString()
            : now.subtract(value, &#39;hours&#39;).toISOString();
        case &#39;d&#39;:
          return operator === &#39;+&#39;
            ? now.add(value, &#39;days&#39;).toISOString()
            : now.subtract(value, &#39;days&#39;).toISOString();
        case &#39;w&#39;:
          return operator === &#39;+&#39;
            ? now.add(value, &#39;weeks&#39;).toISOString()
            : now.subtract(value, &#39;weeks&#39;).toISOString();
        case &#39;M&#39;:
          return operator === &#39;+&#39;
            ? now.add(value, &#39;months&#39;).toISOString()
            : now.subtract(value, &#39;months&#39;).toISOString();
        case &#39;y&#39;:
          return operator === &#39;+&#39;
            ? now.add(value, &#39;years&#39;).toISOString()
            : now.subtract(value, &#39;years&#39;).toISOString();
        default:
          // Handle other units as needed
          return now.toISOString();
      }
    }

    return now.toISOString();
  };
</pre></div>
</div>
<div class="toctree-wrapper compound">
</div>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../asset_health_dashboard/index.html" class="btn btn-neutral float-left" title="Asset Health Dashboard" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../process_correlation/index.html" class="btn btn-neutral float-right" title="Process Correlation" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, 4PointX.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>